#TEMPLATE(Crystal_Reports,'Templates for Crystal Reports'),Family('ABC')
#HELP('CRW.HLP')
#!###########################################################################
#EXTENSION(GlobalDeclarations, 'Include Crystal Report Declarations into Application' ),APPLICATION
#!
#BUTTON('Crystal Reports Template Options'),AT(10,,200)
    #DISPLAY(' This template includes the most common CRW declarations'),AT(,50)
    #DISPLAY(' It was designed for version 6.0 of CRW'),AT(,60)
#ENDBUTTON
#!
#!----------------------------------------------------------------------------
#!
#AT(%CustomGlobalDeclarations)
  #IF(%Target32)
      #PROJECT('CRPE32.LIB')
  #ELSE
      #PROJECT('CRPE.LIB')
  #ENDIF
#ENDAT
#!------------------------------------------------------------------------
#AT(%GlobalMap)
!Crystal Reports DLL print engine call definitions
  #IF(%Target32)
      MODULE('CRPE32.DLL')                                  ! Crystal Reports Library Declaration
  #ELSE
      MODULE('CRPE.DLL')                                  ! Crystal Reports Library Declaration
  #ENDIF
        PECancelPrintJob(SHORT),PASCAL
        PECloseEngine(),PASCAL
        PEClosePrintJob(SHORT),BYTE,PASCAL
        PECloseWindow(SHORT),PASCAL
        PEGetErrorCode(SHORT),SHORT,PASCAL
        PEGetErrorText(SHORT,*CSTRING,*SHORT),BYTE,PASCAL
        PEGetNTables(SHORT),PASCAL
        PEGetNthTableLocation(SHORT,SHORT,*GROUP),RAW,BYTE,PASCAL
        PEOpenEngine(),BYTE,PASCAL
        PEOpenPrintJob(*CSTRING),RAW,SHORT,PASCAL
        PEOutputToPrinter(SHORT,SHORT),BYTE,PASCAL
        PEOutputToWindow(SHORT,*CSTRING,SHORT,SHORT,SHORT,SHORT,LONG,SHORT),RAW,BYTE,PASCAL
        PEPrintControlsShowing(SHORT,*BYTE),RAW,BYTE,PASCAL
        PEPrintReport(*CSTRING,BYTE,BYTE,*CSTRING,SHORT,SHORT,SHORT,SHORT,LONG,SHORT),RAW,SHORT,PASCAL
        PEPrintWindow(SHORT,BYTE),BYTE,PASCAL
        PESetGroupSelectionFormula(SHORT,*CSTRING),RAW,BYTE,PASCAL
        PESetFormula(SHORT,*CSTRING,*CSTRING),RAW,BYTE,PASCAL
        PESetReportTitle(SHORT,*CSTRING),RAW,BYTE,PASCAL
        PESetSelectionFormula(SHORT,*CSTRING),RAW,BYTE,PASCAL
        PESetSectionFormat(SHORT,SHORT,*GROUP),RAW,BYTE,PASCAL
        PESetNthTableLocation(SHORT,SHORT,*GROUP),RAW,BYTE,PASCAL
        PESetWindowOptions(SHORT,*GROUP),RAW,BYTE,PASCAL
        PEShowFirstPage(SHORT),BYTE,PASCAL
        PEShowNextPage(SHORT),BYTE,PASCAL
        PEShowPreviousPage(SHORT),BYTE,PASCAL
        PEShowLastPage(SHORT),BYTE,PASCAL
        PEShowPrintControls(SHORT,BYTE),BYTE,PASCAL
        PEStartPrintJob(SHORT,BYTE),BYTE,PASCAL
    END
#ENDAT
#!------------------------------------------------------------------------
#AT(%GlobalData)

!Crystal Reports Equates

PE_UNCHANGED            EQUATE(-1)      !Wert nicht ,ndern

PE_ALLSECTIONS          EQUATE(0)       !Legt den angegebenen Wert als Wert f?r alle Bereiche fest.
PE_HEADERSECTION        EQUATE(2000)    !Legt den angegebenen Wert als Wert f?r den Seitenkopfbereich fest.
PE_GROUPHEADER          EQUATE(3000)    !*Legt den angegebenen Wert als Wert f?r den Gruppenkopfbereich  fest.
PE_DETAILSSECTIONS      EQUATE(4000)    !Legt den angegebenen Wert als Wert f?r den Detailbereich fest.
PE_GROUPFOOTER          EQUATE(5000)    !*Legt den angegebenen Wert als Wert f?r den Gruppenfubereich fest.
PE_GRANDTOTALSECTIONS   EQUATE(6000)    !Legt den angegebenen Wert als Wert f?r den Gesamtergebnisbereich fest.
PE_FOOTERSECTION        EQUATE(7000)    !Legt den angegebenen Wert als Wert f?r den Seitenfubereich fest.

CW_USEDEFAULT               EQUATE(-32768)
WS_MINIMIZE                 EQUATE(536870912)
WS_VISIBLE                  EQUATE(268435456)
WS_DISABLED                 EQUATE(134217728)
WS_CLIPSIBLINGS             EQUATE(67108864)
WS_CLIPCHILDREN             EQUATE(33554432)
WS_MAXIMIZE                 EQUATE(16777216)
WS_CAPTION                  EQUATE(12582912)
WS_BORDER                   EQUATE(8388608)
WS_DLGFRAME                 EQUATE(4194304)
WS_VSCROLL                  EQUATE(2097152)
WS_HSCROLL                  EQUATE(1048576)
WS_SYSMENU                  EQUATE(524288)
WS_THICKFRAME               EQUATE(262144)
WS_MINIMIZEBOX              EQUATE(131072)
WS_MAXIMIZEBOX              EQUATE(65536)

CR:GFilename                STRING(100)     ! Filename for Export to DBase3
#ENDAT
#!###########################################################################
#EXTENSION(CrystalLocalData,'Crystal Reports Local Data'),PROCEDURE
#!
#! Crystal Reports Local Declarations
#LOCALDATA

PETableLocation     GROUP,PRE(CR_TL)
StructSize1             SHORT
Location                CSTRING(256)
                    END

PEExportOptions      GROUP, PRE(CR_EO)
StructSize2             SHORT
FormatDLLName           CSTRING(64)
FormatType              ULONG
FormatOptions           LONG
DestinationDLLName      CSTRING(64)
DestinationType         ULONG
DestinationOptions      LONG
nFormatOptionsBytes     SHORT
DestinationOptionsBytes SHORT
                     END

PESectionOptions     GROUP, PRE(CR_SO)
Structsize3             SHORT
Visible                 SHORT
NewPageBefore           SHORT
NewPageAfter            SHORT
KeepTogether            SHORT
SuppressBlankLines      SHORT
ResetPageNAfter         SHORT
PrintAtBottomOfPage     SHORT
                     END

PEWindowOptions      GROUP, PRE(CR_WO)
StructSize4             SHORT(26)
HasGroupTree            SHORT(0)
CanDrillDown            SHORT(0)
HasNavigationControls   SHORT(1)
HasCancelButton         SHORT(1)
HasPrintButton          SHORT(1)
HasExportButton         SHORT(1)
HasZoomControl          SHORT(1)
HasCloseButton          SHORT(0)
HasProgressControls     SHORT(1)
HasSearchButton         SHORT(0)
HasPrintSetupButton     SHORT(0)
HasRefreshButton        SHORT(0)
                     END

CR:ReportFileName           CSTRING(65)     ! Report (RPT) file name
CR:SelectionFormula         CSTRING(500)
CR:GroupSelectionFormula    CSTRING(500)
CR:WindowTitle              CSTRING(65)     ! Preview window title

CR:PrintJob                 SHORT(0)
CR:HWnd                     SHORT(0)        ! Hwnd property
CR:ErrorCode                SHORT(0)        ! Used to retrieve error code
CR:ErrorText                CSTRING(255)        ! Used to retrieve error code
CR:ErrorTextLen             SHORT(0)        ! Used to retrieve error code

CR:S1                       CSTRING(500)
CR:S2                       CSTRING(500)

#ENDLOCALDATA


#!###########################################################################
#CODE (CallCrystalReports, 'Call a Crystal Report'),REQ(CrystalLocalData)
  #SHEET,HSCROLL
   #TAB('&General')
    #PROMPT('Report File Name',@s100),%CRFileName,REQ
    #PROMPT('Selection Formula',@s255),%CRSF
    #PROMPT('Group Selection',@s255),%CRGSF
    #PROMPT('Open Report Engine',CHECK),%CROpenEngine,DEFAULT(1)
    #PROMPT('Close Report Engine',CHECK),%CRCloseEngine,DEFAULT(1)
  #ENDTAB
  #TAB('&Window Options')
    #PROMPT('Window Handle',@s50),%CRWindowHandle,DEFAULT('AppFrame{{PROP:Handle}')
    #PROMPT('Window Caption',@s50),%CRWindowTitle,DEFAULT('Report')
    #PROMPT('Start Width',@s50),%CRWidth,DEFAULT(400)
    #PROMPT('Start Height',@s50),%CRHeight,DEFAULT(400)
  #ENDTAB
  #TAB('&Formula Overwrites')
   #BUTTON('Formulas'),MULTI(%CRMultiFormulas,CLIP(%CRFN) &' - '&%CRFV),INLINE
    #PROMPT('Formula Name',@s30),%CRFN,REQ
    #PROMPT('Formula Value',@s200),%CRFV,REQ
   #ENDBUTTON
  #ENDTAB
 #ENDSHEET
#ATSTART
#DECLARE(%VC)
#ENDAT
#!============================================================================================
  LOOP                                                           !LOOP for BREAK control
    SETCURSOR(CURSOR:WAIT)                                       ! Show user what's going on
 #IF (%CrOpenEngine)
    If ~PEOpenEngine()                                           ! Open the print engine
      CR:ErrorCode = PEGetErrorCode(CR:PrintJob)
      Message('Error Starting Report Engine|Error :' & CR:ErrorCode,'Error',ICON:HAND)
      BREAK
    END
 #ENDIF
    CR:SelectionFormula = ''                                     ! Clear values
    CR:GroupSelectionFormula = ''                                !
    CR:ReportFileName = ''                                       !
    CR:ErrorCode = 0                                             !
    CR:HWnd = %CRWindowHandle
    CR:WindowTitle = ''                                          !
 #IF (SUB(%CRFileName,1,1) = '!')
   #SET(%VC,SUB(%CRFileName,2,LEN(%CRFileName)-1))
    CR:ReportFileName = %VC                                     ! Initialize Reportfilename
 #ELSE
    CR:ReportFileName = '%CRFileName'                           ! Initialize Reportfilename
 #ENDIF
 #IF (SUB(%CRWindowTitle,1,1) = '!')
   #SET(%VC,SUB(%CRWindowTitle,2,LEN(%CRWindowTitle)-1))
    CR:WindowTitle = %VC                                        ! Initialize Window
 #ELSE
    CR:WindowTitle = '%CRWindowTitle'                           ! Initialize Window
 #ENDIF
    #EMBED(%CRBeforeOpenPrintJob,'Before Opening Print Job')
    CR:PrintJob  = PEOpenPrintJob(CR:ReportFileName)             ! Open the print engine
    IF CR:PrintJob                                               !  Opening was ok
      #EMBED(%CRAfterOpenPrintJob,'After Opening Print Job')
#! #IF(%CRAfterPrintJobOpening)
#!   %CRAfterPrintJobOpening
#! #ENDIF
 #IF (SUB(%CRSF,1,1) = '!')
   #SET(%VC,SUB(%CRSF,2,LEN(%CRSF)-1))
      CR:SelectionFormula = %VC
 #ELSE
      CR:SelectionFormula = '%CRSF'
 #ENDIF
 #IF (SUB(%CRGSF,1,1) = '!')
   #SET(%VC,SUB(%CRGSF,2,LEN(%CRGSF)-1))
      CR:GroupSelectionFormula = %VC
 #ELSE
      CR:GroupSelectionFormula = '%CRGSF'
 #ENDIF
      IF CLIP(CR:SelectionFormula)
        IF ~PESetSelectionFormula(CR:PrintJob,CR:SelectionFormula)
          CR:ErrorCode = PEGetErrorCode(CR:PrintJob)
          Message('Error in selection formula: ' & CR:ErrorCode,'Error',ICON:HAND)
          BREAK
        END
      END
      IF CLIP(CR:GroupSelectionFormula)
        IF ~PESetGroupSelectionFormula(CR:PrintJob,CR:GroupSelectionFormula)
          CR:ErrorCode = PEGetErrorCode(CR:PrintJob)
          Message('Error in group selection formula: ' & CR:ErrorCode,'Error',ICON:HAND)
          BREAK
        END
      END
 #FOR(%CRMultiFormulas)
   #IF (SUB(%CRFN,1,1) = '!')
     #SET(%VC,SUB(%CRFN,2,LEN(%CRFN)-1))
      CR:S1 = %VC
   #ELSE
      CR:S1 = '%CRFN'
   #ENDIF
   #IF (SUB(%CRFV,1,1) = '!')
     #SET(%VC,SUB(%CRFV,2,LEN(%CRFV)-1))
      CR:S2 = '"'&CLIP(%VC)&'"'
   #ELSE
      CR:S2 = '"%CRFV"'
   #ENDIF
      IF ~PESetFormula(CR:PrintJob,CR:S1,CR:S2)
        CR:ErrorCode = PEGetErrorCode(CR:PrintJob)
        Message('Error in formula '&CLIP(CR:S1) & '|ErrorCode :' & CR:ErrorCode,'Error',ICON:HAND)
        BREAK
      END
 #ENDFOR
      #EMBED(%CRAfterFormulas,'After Formulas,Before Opening Report Window')
      If ~PEOutputToWindow(CR:PrintJob,CR:WindowTitle,0,0,%CRWidth,%CRHeight, |
                     WS_VISIBLE+WS_CAPTION+WS_THICKFRAME+WS_SYSMENU+WS_MAXIMIZEBOX+WS_MINIMIZEBOX, CR:HWnd)
        CR:ErrorCode = PEGetErrorCode(CR:PrintJob)
        Message('Error Creating Window For Print Job|ErrorCode :' & CR:ErrorCode,'Error',ICON:HAND)
        BREAK
      END
      If ~PESetWindowOptions(CR:PrintJob,PEWindowOptions)
        CR:ErrorCode = PEGetErrorCode(CR:PrintJob)
        Message('Error Setting Window Options|ErrorCode :' & CR:ErrorCode,'Error',ICON:HAND)
#!        a# = PEGetErrorText(CR:PrintJob,CR:ErrorText,CR:ErrorTextLen)
#!        Message('Error Setting Window Options|ErrorCode :' & Sub(CR:ErrorText,1,CR:ErrorTextLen),'Error',ICON:HAND)
        BREAK
      END
      #EMBED(%CRStartPrintjob,'Before Running Print Job')
      IF ~PEStartPrintJob(CR:PrintJob, 1)
        CR:ErrorCode = PEGetErrorCode(CR:PrintJob)
        Message('Error when starting the Print Job|ErrorCode :' & CR:ErrorCode,'Error',ICON:HAND)
        BREAK
      END
    ELSE
      Message('Unable to open report :' & CR:ReportFileName,'Error',ICON:HAND)
    END
    BREAK
  END
  IF CR:PrintJob
    CR:ErrorCode = PEClosePrintJob(CR:PrintJob)
  END
 #IF (%CrCloseEngine)
  PECloseEngine()                                                ! Close the print engine
 #ENDIF
  SETCURSOR()
